(function() {
    printLog("inner_image_manager begin");
	
    function _init() {
	    printLog("inner_image_manager _init");
		
		// 初始化参数
	    images = document.getElementsByClassName("image-link");
	    printLog("inner_image_manager images size:" + images.length);
			
	    // 注册图片下载完成的接口
	    window.InnerBridge.registerHandler("jsFunctionNewsImageReady", window.InnerImageManager.jsFunctionNewsImageReady);
    }
	
	function _showImages() {
	    printLog("inner_image_manager _showImages");
			
	    // 调整图片大小,保存信息
		var articleWidth = article.offsetWidth;
		for (var i = 0; i < images.length; i++) {
			var image = images[i];
			var href = image.getAttribute("href");
			if (href == null) {
				continue;
			}
		
			var imageW = image.getAttribute("width");
			var imageH = image.getAttribute("height");
			var adjustedImage = adjustOriginScale(imageW, imageH, articleWidth);
			
			var thumbImageW = image.getAttribute("thumb_width");
			var thumbImageH = image.getAttribute("thumb_height");
			var adjustedThumbImage = adjustOriginScale(thumbImageW, thumbImageH, articleWidth);
			
			image.setAttribute("s_index", i);
			image.setAttribute("s_href", href);
			image.setAttribute("s_width", adjustedImage.w);
			image.setAttribute("s_height", adjustedImage.h);
			image.setAttribute("st_width", adjustedThumbImage.w);
			image.setAttribute("st_height", adjustedThumbImage.h);
	
			image.setAttribute("lazy_href", href);
			
			printLog("inner_image_manager _showImages i:" + i);
			lazyStore.push(image);
	    }
		
		// 加载图片
		_pollImages();
    }
	
	function _showImagesLazy() {
	    printLog("inner_image_manager _showImagesLazy");

		// 加载当前页面图片
		_pollImagesInView();
    }
	
	// 加载屏幕范围内图片
	function _pollImagesInView() {
		printLog("inner_image_manager _pollImagesInView");
		
		var lazyImages = document.getElementsByClassName("lazy_image");
		
		var storedImageSize = lazyImages.length;
		if (storedImageSize > 0) {
			printLog("inner_image_manager _pollImagesInView storedImageSize > 0");
			for (var i = 0; i < storedImageSize; i++) {
				var storedImage = lazyImages[i];
				if (storedImage != null && inView(storedImage)) {
					printLog("inner_image_manager _pollImagesInView storedImage != null && inView(storedImage)");
					var url = storedImage.getAttribute("x_src");
					if (url == null) {
						printLog("inner_image_manager _pollImagesInView href == empty");
						continue;
					}
					var width = storedImage.getAttribute("s_width");
					var height = storedImage.getAttribute("s_height");
					var index = storedImage.getAttribute("s_index");

					//var url = decodeURIComponent(getURLParam(href, "url"));
					printLog("inner_image_manager _pollImagesInView " + i + " url: " + url);
					
					printLog("inner_image_manager _pollImagesInView firstElement " + storedImage.getAttribute("src"));
					storedImage.setAttribute("src", url);
					storedImage.setAttribute("class", "ready_image");
				}
			}
		}
	}
	
	// 加载图片
	function _pollImages() {
		printLog("inner_image_manager _pollImages");
		
		var storedImageSize = lazyStore.length;
		if (storedImageSize > 0) {
			for (var i = 0; i < storedImageSize; i++) {
				var storedImage = lazyStore[i];
				if (storedImage != null) {
					var href = storedImage.getAttribute("lazy_href");
					var width = storedImage.getAttribute("s_width");
					var height = storedImage.getAttribute("s_height");
					var index = storedImage.getAttribute("s_index");

					var url = decodeURIComponent(getURLParam(href, "url"));
					printLog("inner_image_manager _pollImages url:" + url);
					storedImage.setAttribute("s_url", url);
					
					printLog("inner_image_manager _pollImagesInView url:" + url);
					var div = document.createElement("div");
					var defaultImage = "news_default_image.png";
					div.innerHTML = "<img class='lazy_image' x_src='" + url + "' onload='InnerImageManager.appendimg.call(this)' style='display:block' onerror='InnerImageManager.errorimg.call(this)' src='" + defaultImage + "' width='" + width + "' height='" + height + "'/>";

					printLog("inner_image_manager newversion123");
					// 这里要通知java层去下载图片
					//var data = '{"url":"' + url + '", "href":"' + href + '"}';
					//if (window.InnerBridge && href) {
					//	window.InnerBridge.callHandler('funcRequestNewsImages', encodeURIComponent(data), false);
					//} else {
					//	printLog("something is wrong : " + window.InnerBridge + " " + href);
					//}
					var firstElement = div.firstElementChild;
					div.removeChild(firstElement);
					storedImage.appendChild(firstElement);
					storedImage.removeAttribute("lazy_href");
					lazyStore.splice(i, 1);
					storedImageSize = lazyStore.length;
					i--;
				}
			}
		}
	}
	
	// 图片下载完成之后的回调
	function _jsFunctionNewsImageReady(data, responseCallback) {
		printLog("test _newsImageReady");
		
		var result = JSON.parse(data);
		var url = result.url;
		var path = result.path;
	
		printLog("test _newsImageReady images.length: " + images.length);
		var storedImageSize = images.length;
		if (storedImageSize > 0) {
			for (var i = 0; i < storedImageSize; i++) {
				var image = images[i];
				var s_url = image.getAttribute("s_url");
				
				//printLog("test _newsImageReady s_url: " + s_url);
				//printLog("test _newsImageReady url: " + url);
				//printLog("test _newsImageReady path: " + path);
				if (s_url == url) {
					var href = image.getAttribute("href");
					printLog("test newsImageReady href: " + href);
					
					var imageW = image.getAttribute("width");
					var imageH = image.getAttribute("height");
					var width = image.getAttribute("s_width");
					var height = image.getAttribute("s_height");
					var img = document.createElement("img");
					//printLog("test newsImageReady w1: " + imageW + " h1: " + imageH);
					//printLog("test newsImageReady w2: " + width + " h2: " + height);
					img.setAttribute("class", "helloimage");
					img.setAttribute("src", path);
					img.setAttribute("href", "#");
					img.setAttribute("width", width);
					img.setAttribute("height", height);
					image.innerHTML = "";
					image.appendChild(img);
					image.removeAttribute("href");
					break;
				}
			}
		}
	}
	
	function _poolLoop() {
	    _pollImagesInView();
	}

	// 图片加载完成回调
	function _appendimg() {
		printLog("_appendimg");
		this.style.display = "block";
		
	    var node = this.parentNode;
	    _bindLoadOriginImgTrigger(node);
	}

	// 图片加载失败回调
	function _errorimg() {
		printLog("_errorimg");
		
	    var node = this.parentNode;
	    _bindLoadOriginImgTrigger(node);
	}
	
	// 图片点击处理
	function _loadOriginImgHandler(e) {
		printLog("_loadOriginImgHandler");
	}

	// 绑定图片点击事件
	function _bindLoadOriginImgTrigger(node) {
		printLog("_bindLoadOriginImgTrigger");
		
		if (node.getAttribute("s_href") != null) {
			node.setAttribute("href", "javascript:void(0)");
			node.addEventListener("click", _loadOriginImgHandler, false);
		}
	}

	// 取消绑定图片点击事件
	function _unbindLoadOriginImgTrigger(e) {
		printLog("_unbindLoadOriginImgTrigger");
		
		if (node.getAttribute("s_href") != null) {
			node.removeEventListener("click", _loadOriginImgHandler, false);
			node.setAttribute("href", node.getAttribute("s_href"));
		}
	}
	
	var InnerImageManager = window.InnerImageManager = {
	    init: _init,
		showImages: _showImages,
		showImagesLazy: _showImagesLazy,
		appendimg: _appendimg,
		errorimg: _errorimg,
		jsFunctionNewsImageReady:_jsFunctionNewsImageReady,
		poolLoop:_poolLoop
    };
	
	var images = [];
    var lazyStore = [];
	
	var doc = document;
    var readyEvent = doc.createEvent('Events');
    readyEvent.initEvent('InnerImageManagerReady');
    doc.dispatchEvent(readyEvent);
	
	printLog("inner_image_manager end");
})();